create view SAS_BDN_TERM_ATTRIBUTE_VIEW
as
        select ver1.DG_ID as TERM_VERSION_ID,
                term.DG_ID as TERM_ID, 
                term.DG_PID as TERM_PARENT_ID,
                term.DG_RTID as TERM_REAL_TERM_ID,
                term.DG_TTID as TERM_TYPE_ID,
                term.DG_NAME as TERM_NAME, 
                term.DG_TYPE as TERM_TYPE,
                term.DGS_DESC as TERM_DESCRIPTION,
                term.DG_EN as TERM_ENABLED,
                term.DG_SCP as TERM_SCOPE,
                term.DG_LOCK as TERM_ISLOCKED,
                term.DG_WFID as TERM_WORKFLOW_ID,
                term.DG_PEND as TERM_PENDING_DELETE,
                firstVers.DG_CRDT as CREATE_DATE,
                firstVers.DG_UID as CREATED_BY_USER_ID,
                ver1.DG_CRDT as VERSION_CREATE_DATE,
                ver1.DG_UID as VERSION_CREATE_USER_ID,
                term.DG_EN as VER_ENABLED,            
                ver1.DG_VER as VERSION, 
                ver1.DG_MVER as MINOR_VERSION,
                ver1.DG_ISLK as VER_ISLOCKED,
                ver1.DG_LKID as LOCKED_BY_ID,
                ver1.DG_LKDT as LOCKED_DATE,
                item.DG_PID as ITEM_CONTEXT_ID,
                COALESCE(item.PARENT_NAME, item.DG_IK ) as CONTEXT_TYPE,
                item.ITEM_ID,
                item.DG_IK as ITEM_NAME,
                attrib.DG_IAID as ITEM_ATTRIBUTE_ID,
                attrib.ATTRIBUTE_ID,
                attrib.ATTRIBUTE_NAME,
                attrib.DG_ISRQ as ISREQUIRED,
                attrib.ITEM_ATTRIBUTE_VALUES_ID,
                attrib.ITEM_ATTRIBUTE_VALUE  
        from SAS_BDN_DGOVR ver1 
            inner join SAS_BDN_DGOBJS term on ( term.DG_ID = ver1.DG_OID )
            inner join SAS_BDN_DGOVR firstVers on ( term.DG_ID = firstVers.DG_OID) 
            inner join (
                select DG_OID, MIN(DG_VER) as MIN_DG_VER, MIN(DG_MVER) as MIN_DG_MVER
                from SAS_BDN_DGOVR
                where DG_EN in ('Y', 'y')
                group by DG_OID
            ) min_vers on   min_vers.MIN_DG_VER = firstVers.DG_VER and 
                            min_vers.MIN_DG_MVER = firstVers.DG_MVER and 
                            min_vers.DG_OID = firstVers.DG_OID
            left join ( 
                select child.DG_ID as ITEM_ID,
                    child.DG_IK,
                    child.DG_IV,
                    child.DG_PID,
                    parent.DG_IK as PARENT_NAME,
                    dgitvr.DG_OVID 
                from SAS_BDN_DGITVR dgitvr 
                    inner join SAS_BDN_DGIT child on ( dgitvr.DG_IID = child.DG_ID ) 
                    left join SAS_BDN_DGIT parent on ( parent.DG_ID = child.DG_PID ) 
            ) item on (ver1.DG_ID = item.DG_OVID)
            
            left join ( 
                select av.DG_OVID,
                    av.DG_IAID,
                    ia.DG_IID,
                    attr.DG_ID as ATTRIBUTE_ID,
                    attr.DG_ATID,
                    attr.DG_CTID,                        
                    attr.DG_NAME as ATTRIBUTE_NAME,
                    attr.DGS_DESC as ATTRIBUTE_DESCRIPTION,
                    attr.DG_ISRQ,
                    vals.DG_ID as ITEM_ATTRIBUTE_VALUES_ID,
                    vals.DGS_VAL as ITEM_ATTRIBUTE_VALUE                          
                from SAS_BDN_DGIAVR av 
                    inner join SAS_BDN_DGIA ia on ( av.DG_IAID = ia.DG_ID )
                    inner join SAS_BDN_DGATRS attr on ( ia.DG_AID = attr.DG_ID )
                    inner join (
                        select ver.DG_OVID,
                            val.DG_ID,
                            ver.DG_IAID,
                            val.DGS_VAL                        
                        from SAS_BDN_DGITAV val 
                            inner join SAS_BDN_DGIAVV ver on ( ver.DG_IAVID = val.DG_ID )  
                        ) vals
                        on ( vals.DG_IAID = ia.DG_ID  and av.DG_OVID = vals.DG_OVID )
            ) attrib on ( ver1.DG_ID = attrib.DG_OVID  and item.ITEM_ID = attrib.DG_IID );                  
                    

CREATE VIEW SAS_BDN_IA_INFO
AS
SELECT  ia.DG_ID    AS DG_IA_ID, 
        i.DG_ID     AS DG_ITEM_ID, 
        a.DG_ID     AS DG_ATTR_ID, 
        i.DG_IK     AS DG_ITEM_IK, 
        i.DG_PID    AS DG_ITEM_PID, 
        i.DG_OID    AS DG_ITEM_OID, 
        i.DG_IV     AS DG_ITEM_IV, 
        i.DG_EN     AS DG_ITEM_EN, 
        i.DG_LI     AS DG_ITEM_LI,      /*Deprecated?*/
        i.DG_UID    AS DG_ITEM_UID, 
        a.DG_NAME   AS DG_ATTR_NAME, 
        a.DG_ATID   AS DG_ATTR_ATID, 
        a.DG_CTID   AS DG_ATTR_CTID, 
        a.DGS_DESC  AS DGS_ATTR_DESC, 
        a.DG_TYPE   AS DG_ATTR_TYPE, 
        a.DG_ISRQ   AS DG_ATTR_ISRQ, 
        a.DG_CRDT   AS DG_ATTR_CRDT        
FROM    SAS_BDN_DGIT i                              INNER JOIN
        SAS_BDN_DGIA ia     ON i.DG_ID = ia.DG_IID  INNER JOIN
        SAS_BDN_DGATRS a    ON ia.DG_AID = a.DG_ID;

CREATE VIEW SAS_BDN_IV_IA_INFO
AS  
SELECT  iaiv.*,
        iv.DG_OVID  AS DG_IV_OVID, 
        iv.DG_IID   AS DG_IV_IID        
FROM    SAS_BDN_DGITVR iv INNER JOIN
        SAS_BDN_IA_INFO iaiv ON iv.DG_IID = iaiv.DG_ITEM_ID;

CREATE VIEW SAS_BDN_IV_IAV_VALS_INFO
AS  
SELECT  iatviv.*, 
        iavals.DG_ID    AS DG_IAVALS_ID, 
        iavals.DGS_VAL  AS DG_IAVALS_VAL 
FROM    SAS_BDN_IV_IA_INFO iatviv                                           INNER JOIN
        SAS_BDN_DGIAVV iavv     ON  iatviv.DG_IV_OVID   = iavv.DG_OVID AND 
                                    iavv.DG_IAID        = iatviv.DG_IA_ID   LEFT OUTER JOIN
        SAS_BDN_DGITAV iavals   ON  iavv.DG_IAVID = iavals.DG_ID
;

CREATE VIEW SAS_BDN_OBJ_VALS_INFO
AS      
SELECT  /* object columns  */
        o.DG_ID     AS DG_OBJ_ID, 
        o.DG_NAME   AS DG_OBJ_NAME, 
        o.DG_PID    AS DG_OBJ_PARENT_ID,
        o.DG_TTID   AS DG_OBJ_TYPE_ID,
        o.DG_TYPE   AS DG_OBJ_TYPE, 
        o.DG_EN     AS DG_OBJ_EN, 
        o.DG_ACTV   AS DG_OBJ_ACTV, 
        o.DG_SCP    AS DG_OBJ_SCP, 
        o.DG_LOCK   AS DG_OBJ_LOCK, 
        o.DG_PID    AS DG_OBJ_PID,
        o.DG_RTID   AS DG_OBJ_RTID,
        o.DG_WFID   AS DG_OBJ_WFID,
        o.DG_PEND   AS DG_OBJ_PEND,
        /* object version columns */
        ov.DG_ID    AS DG_OV_ID,  
        ov.DG_VER   AS DG_OV_VER, 
        ov.DG_MVER  AS DG_OV_MVER, 
        ov.DG_LBL   AS DG_OV_LBL, 
        ov.DG_EN    AS DG_OV_EN, 
        ov.DG_ACTV  AS DG_OV_ACTV, 
        ov.DG_SCP   AS DG_OV_SCP, 
        ov.DG_UID   AS DG_OV_UID, 
        ov.DG_ISLK  AS DG_OV_ISLK, 
        ov.DG_LKID  AS DG_OV_LKID, 
        ov.DG_LKDT  AS DG_OV_LKDT, 
        ov.DG_CRDT  AS DG_OV_CRDT, 
        /* root view columns */
    rootView.*      
FROM    SAS_BDN_DGOBJS o                                            INNER JOIN
        SAS_BDN_DGOVR ov                    ON o.DG_ID = ov.DG_OID  INNER JOIN
        SAS_BDN_IV_IAV_VALS_INFO rootView   ON ov.DG_ID = rootView.DG_IV_OVID
;

CREATE VIEW SAS_BDN_ENABLED_OBJS
AS
SELECT  o.DG_ID     AS DG_OBJ_ID, 
        o.DG_NAME   AS DG_OBJ_NAME, 
        o.DG_PID    AS DG_OBJ_PARENT_ID,        
        o.DG_TTID   AS DG_OBJ_TYPE_ID, 
        o.DG_TYPE   AS DG_OBJ_TYPE, 
        o.DG_EN     AS DG_OBJ_EN, 
        o.DG_ACTV   AS DG_OBJ_ACTV, 
        o.DG_SCP    AS DG_OBJ_SCP, 
        o.DG_LOCK   AS DG_OBJ_LOCK, 
        o.DG_PID    AS DG_OBJ_PID,
        o.DG_RTID   AS DG_OBJ_RTID
FROM    SAS_BDN_DGOBJS o
WHERE   (DG_EN IN ('Y', 'y'))
;

CREATE VIEW SAS_BDN_ENABLED_OV_INFO
AS
SELECT  ov.DG_ID    AS DG_OV_ID,
        ov.DG_VER   AS DG_OV_VER, 
        ov.DG_MVER  AS DG_OV_MVER,
        ov.DG_LBL   AS DG_OV_LBL, 
        ov.DG_EN    AS DG_OV_EN, 
        ov.DG_ACTV  AS DG_OV_ACTV, 
        ov.DG_SCP   AS DG_OV_SCP, 
        ov.DG_UID   AS DG_OV_UID, 
        ov.DG_ISLK  AS DG_OV_ISLK, 
        ov.DG_LKID  AS DG_OV_LKID, 
        ov.DG_LKDT  AS DG_OV_LKDT, 
        ov.DG_CRDT  AS DG_OV_CRDT,
        eo.*
FROM    SAS_BDN_ENABLED_OBJS eo INNER JOIN
        SAS_BDN_DGOVR ov ON eo.DG_OBJ_ID = ov.DG_OID
WHERE   (ov.DG_EN IN ('Y', 'y'))
;
            
CREATE VIEW SAS_BDN_CURR_OBJ_VER_IDS
AS
SELECT      DG_OBJ_ID       AS DG_OBJ_ID,
            DG_OV_ID        AS DG_OV_ID,             
            MAX(eov.DG_OV_VER)  AS DG_CURR_OV_VER           
FROM        SAS_BDN_ENABLED_OV_INFO eov
GROUP BY    DG_OBJ_ID, DG_OV_ID
;

CREATE VIEW SAS_BDN_CURR_OBJ_VER_INFO
AS
SELECT  objValsInfo.*
FROM    SAS_BDN_OBJ_VALS_INFO       objValsInfo     INNER JOIN
        SAS_BDN_CURR_OBJ_VER_IDS    currObjVerIds   ON objValsInfo.DG_OV_ID = currObjVerIds.DG_OV_ID
;
        
CREATE VIEW SAS_BDN_STARTUP_ATTRIBUTES
AS
SELECT i.DG_ID      AS ITEM_ID, 
       i.DG_PID     AS PARENT_ID, 
       (SELECT DG_IK FROM SAS_BDN_DGIT WHERE DG_ID = i.DG_PID) AS PARENT_ITEM_KEY,
       i.DG_IK      AS ITEM_KEY, 
       i.DG_IV      AS ITEM_VALUE, 
       a.DG_ID      AS ATTRIBUTE_ID, 
       a.DG_NAME    AS NAME, 
       iav.DG_ID    AS ITEM_ATTRIBUTE_VALUE_ID, 
       iav.DGS_VAL  AS BIGSTRVALUE, 
       iavv.DG_OVID AS OBJECT_VERSION_ID
FROM SAS_BDN_DGIT i                                 INNER JOIN 
     SAS_BDN_DGIA ia     ON i.DG_ID = ia.DG_IID     INNER JOIN 
     SAS_BDN_DGATRS a    ON a.DG_ID = ia.DG_AID     INNER JOIN
     SAS_BDN_DGIAVV iavv ON ia.DG_ID = iavv.DG_IAID INNER JOIN
     SAS_BDN_DGOBJS o    ON o.DG_ID = i.DG_OID      INNER JOIN
     SAS_BDN_DGITAV iav  ON iav.DG_ID = iavv.DG_IAVID
