<%@ include file="/WEB-INF/jsp/header.jsp" %>

<script>
    //global
    function queryEndpoint(endpoint, method, interval){
       $.ajax({
           "url":endpoint,
           "type":method,
           "dataType":"json",
           "cache":false,
       }).done(function(data, status, xhr){
            //.done is called when the request succeeds
            // look at the data that came back and do something with it
            // data should actually be escaped to prevent xss here.
            if (data.text.length != 0)
            {
                var returnedData = data.text;
                 $("#logNode").append(returnedData);
                 $("html, body").animate({ scrollTop: $(document).height() }, "fast");
            }
            if (data.complete)
            {
                $("#statusNode").empty();
                $("#statusNode").append("Complete: ");
                if (data.status == "SUCCESS")
                {
                    $("#statusNode").append("Success");
                    $("#statusNode").css("color", "green");
                }
                else if (data.status == "ERROR")
                {
                    $("#statusNode").append("Error");
                    $("#statusNode").css("color", "red");
                }
                else if (data.status == "WARNING")
                {
                    $("#statusNode").append("Warning");
                    $("#statusNode").css("color", "#D0B010");
                }
                $("html, body").animate({ scrollTop: 0 }, "slow");
            }
            else
            {
                var timeoutHandle = setTimeout(function(){
                    queryEndpoint(endpoint, method, interval);
                }, interval);
            }
        }).fail(function(data, status, xhr)
        {
            //.fail is called when the request fails
            $("#statusNode").empty();
            $("#statusNode").append("Failed to read status from midtier.");
            $("#statusNode").css("color", "red");
            $("html, body").animate({ scrollTop: 0 }, "slow");
        });
    }

    //wait until we're fully loaded to start
    $(document).ready(function(){
        
        var interval = 1000;
        var endpoint = "status";
        var method = "GET";
        // query for a reference to the domNode with id "statusNode"
        queryEndpoint(endpoint, method, interval);
        
    });
</script>

<h1>Business Data Network Migration Status</h1>
    
<div><p><strong>Status: </strong><span id="statusNode" style="color:blue;">Running</span></p></div>
<h3>Log</h3>
<pre id=logNode></pre>

<%@ include file="/WEB-INF/jsp/footer.jsp" %>
