<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="utf-8"%>
<%@ page trimDirectiveWhitespaces="true" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"  %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>
<%@ taglib prefix="dmvSearch" tagdir="/WEB-INF/tags/search" %>
<!DOCTYPE html>
<html>
<head>
    <dmvSearch:commonHeadResources />   
</head>
<body class="claro">
	<dmvSearch:header />  
	<dmvSearch:noscript />
    <div class="content" style="display:none;">
    	<div class="resultHeader">
    		<c:url value="${redirectURL}" var="redirectURLTag" />
    		<spring:message code="label.BACK_TO_SEARCH" var="backToSearchLabel" />
    		<p class="backToSearch"><a href="${redirectURLTag}" title="${backToSearchLabel}" >${backToSearchLabel}</a></p>
    		<div class="hr" ></div>
    	</div>
    	<div class="logInFormContainer">
    		<dmvSearch:bookmarklet />
    		<h3><spring:message code="header.REGISTER_BROWSER_SEARCH_PROVIDER" /></h3>
    		<p><spring:message code="label.REGISTER_BROWSER_SEARCH_PROVIDER" /></p>
    		<div id="addIESearchProvider" style="display:none;">
    			<spring:message code="label.ADD_SEARCH_PROVIDER" arguments="Internet Explorer" var="addToIE" />
    			<c:url var="searchURL" value="/search/search.xml" />
    			<input type="button" value="${addToIE}" onClick='window.external.AddSearchProvider("${searchURL}");'>
    		</div>
    		<div id="addFirefoxSearchProvider" style="display:none;">
    			<spring:message code="label.ADD_SEARCH_PROVIDER" arguments="Firefox" var="addToFirefox" />
    			<h4>${addToFirefox}</h4>
    			<p><spring:message code="label.ADD_TO_FIREFOX" /></p>
    			<spring:message code="link.title.ADD_TO_FIREFOX_INSTRUCTIONS" var="firefoxLinkTitle" />
    			<spring:message code="link.href.FIREFOX_SEARCH_PROVIDER" var="firefoxLinkURL" />
    			<p><a href="${firefoxLinkURL}" title="${firefoxLinkTitle}" target="_blank"><spring:message code="label.ADD_TO_FIREFOX_INSTRUCTIONS" /></a></p>
    		</div>
    		
    		<div id="addChromeSearchProvider" style="display:none;">
    			<spring:message code="label.ADD_SEARCH_PROVIDER" arguments="Chrome" var="addToChrome" />
    			<h4>${addToChrome}</h4>
    			<label for="searchEngineNameInput"><spring:message code="label.SEARCH_ENGINE_NAME" /></label>
    			<spring:message code="input.value.SEARCH_ENGINE_NAME" var="searchEngineName"/>
    			<input type="text" readonly="readonly" class="textInput" id="searchEngineNameInput" value="${searchEngineName}" onclick="this.select();" />
    			<spring:message code="input.value.KEYWORD" var="keyword" />
    			<label for="keywordInput"><spring:message code="label.KEYWORD" /></label>
    			<input type="text" readonly="readonly" class="textInput" id="keywordInput" value="${keyword}" onclick="this.select();" />
    			<label for="urlInput"><spring:message code="label.URL_TO_REGISTER" /></label>
    			<input type="text"  readonly="readonly" class="textInput" id="urlInput" value="${chromeSearchString}" onclick="this.select();" />
    			<spring:message code="link.title.ADD_TO_CHROME_INSTRUCTIONS" var="chromeLinkTitle" />
    			<p><a href="https://support.google.com/chrome/bin/answer.py?hl=en&answer=95653" title="${chromeLinkTitle}" target="_blank"><spring:message code="label.ADD_TO_CHROME_INSTRUCTIONS" /></a></p>
    		</div>
    		
    		<div id="noSearchProvider" style="display:none;">
    			<h4><spring:message code="title.UNSUPPORTED_BROWSER" /></h4>
    			<p><spring:message code="label.UNSUPPORTED_BROWSER" /></p>
    		</div>
    	</div>
    </div>
    <c:url var="controllerjsURL" value="${initParam.searchResourcesPathPrefix}/script/dmv/loginController.js" />
	<script>
           require(["dojo/ready","dojo/io/script","dojo/_base/connect", "dojo/query","dojo/dom-style", "dojo/has", "dojo/i18n!i18n/nls/strings"], 
                    function(ready, script, connect, $, domStyle, has, resources) {
        	   			ready(function(){
       	   					console.log("ready");
                            var contentNodes = $(".content");
                            if(contentNodes != null && contentNodes.length > 0){
                            	domStyle.set(contentNodes[0],"display", "block");
                            }
                            var ieDivStyle = "none";
                            var chromeDivStyle = "none";
                            var ffDivStyle = "none";
                            var supportsSearchProvider = false;
                            var ieVer = has("ie");
                            if( ieVer >= 7){
                            	if(ieVer < 9){
                            		var bookmarkletMessageNodes = $("#bookmarkletMessage");
                            		if(bookmarkletMessageNodes != null && bookmarkletMessageNodes.length > 0){
                            			bookmarkletMessageNodes[0].innerHTML = resources.IE_BOOKMARKLET_MESSAGE;
                            		}
                            		var bookmarkletExplanationNodes = $("#bookmarkletExplanation");
                            		if(bookmarkletExplanationNodes != null && bookmarkletExplanationNodes.length > 0){
                            			bookmarkletExplanationNodes[0].innerHTML = resources.IE_BOOKMARKLET_EXPLANATION;
                            		}
                            	}
                            	ieDivStyle = "block";
                            	supportsSearchProvider = true;
                            }
                            if(has("ff") >= 3.6){
                            	ffDivStyle = "block";
                            	supportsSearchProvider = true;
                            }
                            if(has("chrome") >= 13){
                            	chromeDivStyle = "block";
                            	supportsSearchProvider = true;
                            }
                            $("#addIESearchProvider").style("display", ieDivStyle);
                            $("#addFirefoxSearchProvider").style("display", ffDivStyle);
                            $("#addChromeSearchProvider").style("display", chromeDivStyle);
                            if(supportsSearchProvider == false){
                            	$("#noSearchProvider").style("display", "block");
                            }
        	   			});
           			}
           );
    </script>
</body>
</html>