<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="utf-8"%>
<%@ page trimDirectiveWhitespaces="true" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"  %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>
<%@ taglib prefix="dmvSearch" tagdir="/WEB-INF/tags/search" %>
<!DOCTYPE html>
<html>
<head>
    <dmvSearch:commonHeadResources />   
</head>
<body class="claro">
	<c:url value="${loginLinkURL}" var="loginLink">
		<c:param name="${loginLinkParam.key}" value="${loginLinkParam.value}" />
	</c:url>
    <dmvSearch:header showSignInLink="false" isLoggedIn="${isLoggedIn}" loginURL="${loginLink}" />
	<dmvSearch:noscript />
	<div class="content indexContent" style="display:none;">
        <c:url var="searchURL" value="/search" />
        <dmvSearch:searchInputForm formAction="${searchURL}" maxQueryLength="${maxQueryLength}" searchProviders="${registeredSearchProviders}" />
        <c:url value="${extrasURL}" var="extrasLink">
			<c:param name="${extrasParam.key}" value="${extrasParam.value}" />
		</c:url>
		<dmvSearch:footer extrasURL="${extrasLink}" />
    </div>
    <dmvSearch:commonInitScript registeredSearchProviders="${registeredSearchProviders}" selectedSearchProviders="${registeredSearchProviders}" >
    	<jsp:attribute name="postLoadJS">
		    var menu = dijit.byId('searchProviderMenu');
		    if(menu){
			    menu.set('onItemClick',lang.hitch(dmv.search.vars.controller, 'onSearchProviderSelect'));
			    var selectedLen = preselectedProviderIDs.length;
			       for(var i=0; i < selectedLen; i++){
			       	dmv.search.vars.controller.onSearchProviderSelect(dijit.byId(preselectedProviderIDs[i]), null);
			   	}
		   	}
		   	var contentNodes = $(".content");
            if(contentNodes != null && contentNodes.length > 0){
            	domStyle.set(contentNodes[0],"display", "block");
            }
            var searchInput = $("#searchInput");
            if(searchInput && searchInput.length > 0){ 
            	searchInput[0].focus();
            }
        </jsp:attribute>
            
	</dmvSearch:commonInitScript>
</body>
</html>