<%@ page trimDirectiveWhitespaces="true" %>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"  %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>
<%@ taglib prefix="dmvSearch" tagdir="/WEB-INF/tags/search" %>
<!DOCTYPE html>
<html lang="en">
<head>
	<dmvSearch:commonHeadResources />
	<style>
      		.searchInputWrapper{ margin:0; }
    </style>
</head>
<body class="claro">
	<c:url value="${loginLinkURL}" var="loginLink">
		<c:param name="${loginLinkParam.key}" value="${loginLinkParam.value}" />
	</c:url>
	<dmvSearch:header showSignInLink="false" loginURL="${loginLink}" isLoggedIn="${isLoggedIn}" />
	<dmvSearch:noscript />
    <div class="content" style="display:none; margin:0;">
        <div class="resultHeader">
        	<c:url value="${initParam.searchResourcesPathPrefix}/images/StatusError12.png" var="errorImgURL" />
			<spring:message code="img.alt.ERROR" var="errorImgAlt" />
			<c:forEach items="${results.errorMessages}" var="errorMessage"> 
				<spring:message code="label.SEARCH_ERROR_MSG" arguments="${errorMessage.searchProvider.name}" var="errorMessage" />
				<spring:message code="link.label.SIGN_IN_WITH_DIFFERENT_CREDENTIALS" var="errorMessageLink" />
				<spring:message code="link.title.SIGN_IN_WITH_DIFFERENT_CREDENTIALS" var="errorMessageLinkTitle" />
				<div class="resultError">
					<img src="${errorImgURL}" alt="${errorImgAlt}" title="${errorImgAlt}" class="signInErrorImg" />
					<p class="signInErrorMsg">${errorMessage}<a href="${loginLink}" title="${errorMessageLinkTitle}">${errorMessageLink}</a></p>
				</div>
			</c:forEach>
            <div id="searchFormWrapper">
        		<c:url var="searchURL" value="/search" />
            	<dmvSearch:searchInputForm formAction="${searchURL}" maxQueryLength="${maxQueryLength}" searchProviders="${registeredSearchProviders}" queryString="${results.searchString}" />
            </div>
            <div id="resultSummary">
                <div class="resultCount">
                	<spring:message code="label.summary.RESULTS_FOR" arguments="${results.count},${results.searchString}" var="resultsSummary" />
                    <p>${resultsSummary}</p>
                </div>
               <%-- <c:if test="${results.count > 0}"> --%> 
	                <c:forEach items="${results.resultSummary}" var="entry">
	                	<dmvSearch:searchResultSummary summary="${entry.value}" />
	                </c:forEach>
                <%-- </c:if> --%>
                </div>
                <div class="hr" ></div>
            </div>
            
        <c:set var="maxInitialRows" value="5" />
        <c:set var="maxTotalRows" value="500" />
        <div id="results">
        <c:set var="providersWithResultsCount" value="${fn:length(results.searchResults)}" />
        <c:forEach items="${results.searchResults}" var="entry">
        	<c:set var="resultListLength" value="${fn:length(entry.value)}" />
        	<c:set var="curProviderID" value="${entry.key}" />
        	<c:set var="exceededMaxInitialRows" value="false" />
        	<c:set var="exceededMaxTotalRows" value="false" />
        	<c:if test="${resultListLength > 0}">
        	 	<dmvSearch:searchResultProviderEntry summary="${results.resultSummary[entry.key]}" 
        	 										 searchProvider="${entry.value[0].searchProvider}" 
        	 										 maxInitialRows="${maxInitialRows}" 
        	 										 maxRows="${maxTotalRows}"
        	 										 hideShowMoreButton="${providersWithResultsCount <= 1}"
        	 										  />
	           	<c:forEach begin="0" end="${resultListLength-1}" step="1" var="result" >
	           		<c:if test="${providersWithResultsCount > 1}" >
		           		<c:if test="${result == maxInitialRows}">
		           			<c:set var="exceededMaxInitialRows" value="true" />
		           			<div id="__more${curProviderID}" style="display:none;">
		           		</c:if>
	           		</c:if>
	           		<c:choose>
	           			<c:when test="${result < maxTotalRows}">
			       			<dmvSearch:searchResult result="${entry.value[result]}" />
			       		</c:when>
			       		<c:otherwise>
							<c:set var="result" value="${resultListLength}" /> 
			       		</c:otherwise>
			       </c:choose>
	           	</c:forEach>
	           	<c:if test="${providersWithResultsCount > 1}" >
		           	<c:if test="${exceededMaxInitialRows}">
		        		</div>
		           	</c:if>
	           	</c:if>
           	</c:if>
        </c:forEach>
        <c:if test="${providersWithResultsCount < 1 }">
        	<br clear="all" />
        	<h3 class="noResults"><spring:message code="error.NO_SEARCH_RESULTS" arguments="${results.searchString}" /></h3>
        </c:if>
        </div>
        <c:url value="${extrasURL}" var="extrasLink">
			<c:param name="${extrasParam.key}" value="${extrasParam.value}" />
		</c:url>
		<dmvSearch:footer extrasURL="${extrasLink}" />
    </div> 
    <dmvSearch:commonInitScript registeredSearchProviders="${registeredSearchProviders}"
    	selectedSearchProviders="${results.selectedSearchProviders}" >
    	<jsp:attribute name="postLoadJS">
		    var menu = dijit.byId('searchProviderMenu');
		    
		    menu.set('onItemClick',lang.hitch(dmv.search.vars.controller, 'onSearchProviderSelect'));
		    var selectedLen = preselectedProviderIDs.length;
		       for(var i=0; i < selectedLen; i++){
		       	dmv.search.vars.controller.onSearchProviderSelect(dijit.byId(preselectedProviderIDs[i]), null);
		   	}
		   	var contentNodes = $(".content");
            if(contentNodes != null && contentNodes.length > 0){
            	domStyle.set(contentNodes[0],"display", "block");
            }
            </jsp:attribute>
	</dmvSearch:commonInitScript>
</body>
</html>