<%@ tag language="java" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"  %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>
<%@ taglib prefix="dmvSearch" tagdir="/WEB-INF/tags/search" %>
<%@ attribute name="registeredSearchProviders" type="java.util.List" required="true" rtexprvalue="true" %>
<%@ attribute name="selectedSearchProviders" type="java.util.List" required="true" rtexprvalue="true" %>
<%@ attribute name="postLoadJS" type="java.lang.String" required="false" rtexprvalue="true" %>

   		<c:url var="controllerjsURL" value="${initParam.searchResourcesPathPrefix}/script/dmv/searchController.js" />
		<script>
            
            <c:set var="selectedSearchProviderJSObject" value="" />
            <c:set var="searchProviderJSObject" value="" />
	        <c:forEach items="${registeredSearchProviders}" var="searchProvider">
					<c:url value="${searchProvider.iconPath}" var="iconURL" />
		        	<c:set var="searchProviderJSObject" value="${searchProviderJSObject}${searchProvider.ID}:{icon:\"${iconURL}\", cssClass:\"${searchProvider.ID}dijitIconClass\", name:\"${searchProvider.name}\"}, " />
	        </c:forEach>
	        <c:forEach items="${selectedSearchProviders}" var="selectedSearchProvider">
	        	<c:set var="selectedSearchProviderJSObject" value="${selectedSearchProviderJSObject}\"${selectedSearchProvider.ID}MenuItem\"," />
	        </c:forEach>
	           require(["dojo/ready",
	                    "dojo/query",
	                    "dojo/_base/lang",
	                    "dojo/io/script",
	                    "dojo/_base/connect",
	                    "dojo/dom-style",
	                    "dijit/form/ToggleButton", 
	                    "dijit/form/ComboButton", 
	                    "dijit/Menu", 
	                    "dijit/MenuItem", 
	                    "dijit/form/DropDownButton", 
	                    "dijit/TooltipDialog"], 
	                    function(ready, $, lang, script, connect, domStyle, ToggleButton, ComboButton, Menu, MenuItem, DropDownButton, TooltipDialog) {
	        	   			ready(function(){
        	   					// the searchController is going to publish a searchControllerReady topic when it's 
        	   					// finished initializing.  Listen for it here.  If this check isn't made the call to 
        	   					// create the searchController object fails becasue it hasn't finished initializing 
        	   					// even though it's done loading.
        	   					var handle = connect.subscribe("searchControllerReady", function(){
	        	   					console.log("connected");
	        	   					var preselectedProviderIDs = [${fn:substring(selectedSearchProviderJSObject,0,fn:length(selectedSearchProviderJSObject)-1)}]; 
                         	       	var searchProviderInfo = {${fn:substring(searchProviderJSObject,0,fn:length(searchProviderJSObject)-2)}};
                                    dmv.search.vars.controller = new dmv.search.searchController(searchProviderInfo);
                                    
                                    ${postLoadJS}
                                    if(dmv.search.vars.controller.doesBrowserSupportOpenSearch()){
                                    	$("#footer").style("display", "block");
                                    }
	                            	connect.unsubscribe(handle);
	        	   				});
           	   					script.get({
	                                url:"${controllerjsURL}",
	                                load: function(evt){
	                                	console.log("loaded");
	                                }
                               });
	        	   			});
            			});
    </script>