<%@ tag language="java" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"  %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>
<%@ attribute name="searchProviders" type="java.util.List" required="true" rtexprvalue="true" %>
<%@ attribute name="formAction" required="true" rtexprvalue="true" %>
<%@ attribute name="maxQueryLength" type="java.lang.Integer" required="true" rtexprvalue="true" %>
<%@ attribute name="queryString" required="false" rtexprvalue="true" %>
		<%-- generate a style for each menu item so the icon is displayed properly --%>
		
		<style>
		<c:forEach items="${searchProviders}" var="searchProvider">
			<c:url value="${searchProvider.iconPath}" var="iconURL" />	
        	.${searchProvider.ID}dijitIconClass
        	{
        		background:url('${iconURL}') no-repeat 0px 1px;
			    width:18px;
			    height:18px;
			    border: 1px solid transparent;
        	}
        </c:forEach>
        </style>
        <c:set var="searchProvidersAvailable" value="${fn:length(searchProviders) > 0}" />
        <c:if test="${searchProvidersAvailable == true}">
	        <spring:message code="button.title.SELECT_SEARCH_PROVIDERS" var="dropdownButtonTip" />
	        <spring:message code="input.title.SEARCH" var="searchButtonTip" />
			<form name="dmvSearch" action="${formAction}" method="get" onsubmit="return dmv.search.vars.controller.submitSearch(this);">
	             <div class="searchInputWrapper" >
	             	<div id="dropdownUnderlay"></div>
	                <div id="dropDown" title="${dropdownButtonTip}" data-dojo-type="dijit.form.DropDownButton" data-dojo-props="iconClass:'', 
	                                     label:'',
	                                     onMouseOver: function(evt){
	                                     	dmv.search.vars.controller.onDropDownMouseOver(this);
	                                     },
	                                     onMouseOut: function(evt){
	                                     	dmv.search.vars.controller.onDropDownMouseOut(this);
	                                     },
	                                     showLabel:true">
	                    <div id="searchProviderMenu" style="display:none;" data-dojo-type="dijit.Menu" >
	                    <c:forEach items="${searchProviders}" var="searchProvider">
	                    	<div data-dojo-type="dijit.MenuItem" id="${searchProvider.ID}MenuItem"
	                             data-dojo-props="iconClass:'${searchProvider.ID}dijitIconClass'">
	                             ${searchProvider.name}
	                        </div>
	                    </c:forEach>
	                        <div data-dojo-type="dijit.MenuItem" data-dojo-props="type:'close'">
	                            <p class="closeLink">Close</p>
	                        </div>
	                    </div>
	                </div>
	                 
	                <input type="text" name="q" id="searchInput" value="${queryString}" maxlength="${maxQueryLength}">
	                <input type="submit" value="" alt="${searchButtonTip}" title="${searchButtonTip}" id="searchButton" 
	                	   onmouseover="dmv.search.vars.controller.onSubmitMouseOver()" onmouseout="dmv.search.vars.controller.onSubmitMouseOut()" />
	                <div id="searchButtonUnderlay"></div>
	            </div>
	        </form>
        </c:if>
        <c:if test="${searchProvidersAvailable == false}">
        	<div class="errorMsgWrapper">
        		<p class="errorMsg"><spring:message code="error.NO_SEARCH_PROVIDERS" /></p>
        	</div>
        </c:if>