<%@ tag language="java" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib uri="http://www.springframework.org/tags" prefix="spring"%>
<%@ attribute name="summary" type="com.sas.svcs.dm.businessdata.search.model.SearchProviderSummary" required="true" rtexprvalue="true" %>
<%@ attribute name="searchProvider" type="com.sas.svcs.dm.search.client.model.ISearchProvider" required="true" rtexprvalue="true" %>
<%@ attribute name="maxRows" type="java.lang.Integer" required="true" rtexprvalue="true" %>
<%@ attribute name="maxInitialRows" type="java.lang.Integer" required="true" rtexprvalue="true" %>
<%@ attribute name="hideShowMoreButton" type="java.lang.Boolean" required="false" rtexprvalue="true" %>
<c:set var="maxInitialRowsAdjusted" value="${maxInitialRows}" />
<c:if test="${hideShowMoreButton}">
	<c:set var="maxInitialRowsAdjusted" value="${maxRows}" />
</c:if>
<div class="resultSummaryProviderItem">
	<a name="${searchProvider.ID}"> </a>
	<p id="__summaryHeader${summary.searchProviderID}">
	   <c:choose>
	   		<c:when test="${summary.resultCount <= maxInitialRowsAdjusted }">
	   			${summary.resultCount} ${summary.summaryDescription}
	   		</c:when>
	   		<c:otherwise>
   				<spring:message code='link.title.SHOW_MORE' var="showMoreTitle" />
	   			<span class="summaryCountSpan"><spring:message code='label.TOP' /> ${maxInitialRowsAdjusted}</span> ${summary.summaryDescription} 
	   			<c:if test="${!hideShowMoreButton}" >
		   			<a href="#showMore" class="showMore" title="${showMoreTitle}"
		   			   onclick="
		   			   dmv.search.vars.controller.toggleMoreLess('${searchProvider.ID}',${summary.resultCount}, ${maxRows}, ${maxInitialRowsAdjusted}); return false;"
		   			><spring:message code='label.SHOW_MORE' /></a>
	   			</c:if>
	   		</c:otherwise>
	   </c:choose> 
	  
	    <c:if test="${searchProvider.supportsSearchByURI}">
	    	<a href="${summary.URL}" title="${summary.linkTitle}" class="openWith" target="_blank"><spring:message code='label.SHOW_ALL_IN' /> ${searchProvider.opensWithName}</a>
	    	<span class="openWith"></span>
	    </c:if>
    </p>
</div>
