/**
 * The bad thing about declare() is that everything is public, which means it's important to stick
 * to the convention of putting an underscore in front of "private" declarations
 */
require(["dojo/_base/declare",
         "dojo/query",
         "dojo/dom-style",
         "dojo/dom-attr",
         "dojo/_base/array",
         "dojo/i18n!i18n/nls/strings",
         "dojo/_base/connect"
         ], 
		function(declare,
				 $,
				 domStyle,
				 domAttr,
				 arrayFunctions,
				 resources,
				 connect
				 ){
  declare("dmv.search.loginController", null, {
	  constructor: function(){},
	  CONST:{CREDENTIALS_UNIQUE:"unique", CREDENTIALS_SHARED:"share"},
	  init:function(){
          this.onCredentialSelectChange($("#loginForm input[name='credentialSelect']"));
          var usernameInput = $("#username")[0];
          if(usernameInput.disabled == false){
          	usernameInput.focus();
          }else{
        	// select the first input that is not one of the master credential inputs
          	var firstInput = ($("input",($(".formEntry",($(".searchProviderCredentialGroup")[0]))[0]))[0]);
          	firstInput.focus();
          }  
	  },
	  onAlternativeCredentialsToggle: function(/*String*/ whichSearchProvider, /*boolean*/ isChecked){
			var affectedInputs = $(".alternativeCredentials .formEntry input");
			console.log(whichSearchProvider+" enabled should now be: "+isChecked);
			arrayFunctions.forEach(affectedInputs, function(/*input*/input, /*int*/ i){
				input.disabled = !isChecked;
				var inputID = domAttr.get(input, "id");
				$("label[for='"+inputID+"']",input.parentNode).toggleClass('__disabledLabel', input.disabled);
			});
	  },
	  onCredentialSelectChange: function(radioButtons /*"unique" | "share"*/){
		  var selectedValue = null;
		  arrayFunctions.some(radioButtons, function(button){
			  var checked = button.checked;
			  if(checked){
				  selectedValue = button.value;
			  }
			  return checked;
		  });
		  var usernameInputNodes = $("#username");
		  var usernameInputNode = null;
		  if(usernameInputNodes && usernameInputNodes.length > 0){
			  usernameInputNode = usernameInputNodes[0];
		  }
		  var passwordInputNodes = $("#password");
		  var passwordInputNode = null;
		  if(passwordInputNodes && passwordInputNodes.length > 0){
			  passwordInputNode = passwordInputNodes[0];
		  }
		  
		  if(selectedValue == this.CONST.CREDENTIALS_SHARED){
			  if(usernameInputNode){
				  usernameInputNode.disabled = false;
			  }
			  
			  if(passwordInputNode){
				  passwordInputNode.disabled = false;
			  }
			  var grp = $(".searchProviderCredentialGroup");
			  grp.style("display", "none");
			  
		  }else if(selectedValue == this.CONST.CREDENTIALS_UNIQUE){
			  // if there is something in the master credentials box already, populate each
			  // input box with that value, as long the value is not already set
			  var inputUsername = "";
			  var inputPassword = "";
			  
			  if(usernameInputNode){
				  inputUsername = usernameInputNode.value;
				  usernameInputNode.disabled = true;
			  }
			  
			  if(passwordInputNode){
				  inputPassword = passwordInputNode.value;
				  passwordInputNode.disabled = true;
			  }
			  $(".alternativeCredentials .formEntry input[name$=\"___username\"]").forEach(function(/*input*/input, /*int*/ i){
				  if(!input.value || input.value.length == ""){
					  input.value = inputUsername;
				  }
			  });
			  
			  $(".alternativeCredentials .formEntry input[name$=\"___password\"]").forEach(function(/*input*/input, /*int*/ i){
				  if(!input.value || input.value.length == ""){
					  input.value = inputPassword;
				  }
			  });
			  
			  var grp = $(".searchProviderCredentialGroup");
			  grp.style("display", "block");
		  }
		  
		  $("label[for='"+usernameInputNode.id+"']",usernameInputNode.parentNode).toggleClass('__disabledLabel', usernameInputNode.disabled);
		  $("label[for='"+passwordInputNode.id+"']",passwordInputNode.parentNode).toggleClass('__disabledLabel', passwordInputNode.disabled);
	  }
	  
	//------------------------------------------------------------------------------------------
	//------------------------"private"---------------------------------------------------------
	//------------------------------------------------------------------------------------------

	  
  });
  console.log("logincontrollerloaded");
  connect.publish("loginControllerReady");
});
  