/**
 * 
 */

//TODO: Try dojo.declare
// search.js lives on for now for historical purposes only.  Instead see searchController.js which uses dojo's declare concept to 
// create the controller class
// make sure the namespace is initialized
var dmv = dmv ? dmv : {};
if(!dmv.search){
	dmv.search = function(searchProviderProperties){
		// "private" members go here
		/*Object*/
		var _handles = {};
		/*Array*/
		var _selectedSearchProviders = [];
		var _searchProviderProperties = searchProviderProperties;
		var _toggledClassSuffix = "__toggled";
		function _isToggledClass(className){
			if(className == null){
				return;
			}
			var reg = new RegExp("^[^\\s]+ "+_toggledClassSuffix+"$");
			return reg.test(className);
		}
		
		function _getToggledClass(className){
			if(_isToggledClass(className)){
				return className;
			}
			return className+" "+ _toggledClassSuffix;
		}
		
		function _getUntoggledClass(className){
			if(_isToggledClass(className) == false){
				return className;
			}
			var reg = new RegExp("^([^\\s]+) "+_toggledClassSuffix+"$");
			var matches = reg.exec(className);
			if(matches.length > 1){
				return matches[1];
			}
			return null;
		}
		
		function _addSelectedSearchProvider(whichClassName){
			if(dojo.indexOf(_selectedSearchProviders,whichClassName) > -1){
				return false;
			}
			_selectedSearchProviders.push(whichClassName);
			return true;
		}
		
		function _removeSelectedSearchProvider(whichClassName){
			var curIndex =dojo.indexOf(_selectedSearchProviders,whichClassName);
			if(curIndex < 0){
				return false;
			}
			_selectedSearchProviders.splice(curIndex, 1);
			return true;
		}
		
		function _translateCSSClassName(whichClassName){
			for(var uiName in _searchProviderProperties){
				if(_searchProviderProperties[uiName]['cssClass'] == whichClassName){
					return uiName;
				}
			}
			return whichClassName;
		}
		
		function _onAfterSearchHandler(){
			console.log('afterselection');
			var dropdown = dijit.byId('dropDown');
	     	dropdown.set("label", generateHTMLIconList());
	     	var counter = _selectedSearchProviders.length;
	     	if(counter > 0){
	     		// the icons that appear on the dropdown button are assigned to the dropdownIcon class
	     		// since the icons are being inserted directly into the html we need to wait until they are
	     		// loaded before attempting to measure them to resize the input box
		     	dojo.query(".dropdownIcon").onload(function(e){
	     			if(--counter <= 0){
	     				resizeInput();
	     			}
	     		});
	     	}else{
	     		// nothing to load, just do the resize
	     		resizeInput();
	     	}
	    }
		function resizeInput(){
			var dropdown = dijit.byId('dropDown');
			// use dojo.marginBox here because we want to include the margin in the calculation
			var mb = dojo.marginBox(dropdown.domNode);
	     	console.log(mb.w);
	     	var searchInput = dojo.byId("searchInput");
	     	var newLeftMargin = mb.w + 5; 
	     	dojo.style(searchInput, "marginLeft",newLeftMargin+"px");
	     	//dojo.position returns the box representing the client area (as opposed to dojo.marginBox)
	     	var pmb = dojo.position(searchInput.parentNode);
	     	var searchButton = dojo.byId("searchButton");
	     	var searchButtonMB = dojo.marginBox(searchButton);
	     	console.log(searchButtonMB);
	     	console.log(pmb.w);
	     	// 5px for padding between the edge of the input box and the search button
	     	var searchInputWidth = searchButtonMB.l - newLeftMargin - dojo.style(searchInput.parentNode, "paddingRight") - 5;
	     	console.log(searchInputWidth);
	     	dojo.style(searchInput, "width",searchInputWidth+"px");
		}
		
		function typeToIconPath(typeStr){
			if(_searchProviderProperties[typeStr]){
				return _searchProviderProperties[typeStr]["icon"];
			}
			return "";	
		}
		
		function generateHTMLIconList(){
			var html = "";
			var searchProviders = __API.getSearchProviders();
			var searchProvidersLen = searchProviders.length;
			for(var i=0; i<searchProvidersLen; i++){
				var imgFilePath = typeToIconPath(searchProviders[i]);
				html+=format("<img src=\"{0}\" class=\"dropdownIcon\"/>", imgFilePath);
			}
			console.log(html);
			return html;
		}
		
		function format(str, replacement0 /* ... */){
			if(arguments.length < 2){
				return str;
			}
			var args = arguments;
			var argLen = args.length;
			var f = function(match, num){
				console.log(num);
				var numArg = parseInt(num);
				if(!isNaN(numArg) && argLen-1 > numArg){
					return args[(numArg+1)];
				}
				return match;
			};
			var reg = /{(\d+)}/gi;
			var newStr = str.replace(reg, f);
			return newStr;
		}
		
		function generateRandomName(length){
			var randomName = "";
			if(isNaN(length) || length < 1){
				length = 8;
			}
			var min = 48;
			var max = 122;
			var range = max - min;
			var i = 0;
			while(i < length){
				var ord = Math.round(Math.random() * range + min);
				if( (ord >= 58 && ord <= 64) || (ord >= 91 && ord <=96)){
					// if ord is in these ranges, it's an invalid character.
					continue;
				}
				randomName+=String.fromCharCode(ord);
				i++;
			}
			return randomName;
		}
		
		function _bindSetter(/*Function*/ setter, /*Object*/ host, /*String*/ boundFunctionName ){
			var randomName = generateRandomName();
			__API.setHandle(randomName, __API.dojoConnect(host, boundFunctionName, null, setter));
			console.log("handle stored with key "+randomName);
			return randomName;
		}
		
		function _unbindSetter(/*String*/ handleName){
			__API.dojoDisconnect(handleName);
		}
		
		// return the api
		var __API =  {
			getHandle: function(handleName){
				return _handles[handleName];
			},
			/**
			 * @param {String} handleName
			 * @param {Handle} value
			 * @return {Boolean} return true if the handle was created, false if the value was overridden
			 */
			setHandle: function(/*String*/ handleName, /*Handle*/ value){
				var handleAlreadyExists = _handles[handleName] == true;
				_handles[handleName] = value;
				return handleAlreadyExists;
			},
			
			getSearchProviders:function(){
				// translate the css class names into something more appropriate for the server to use
				var searchProviderLen = _selectedSearchProviders.length;
				var translatedSearchProviderArray = new Array(searchProviderLen)
				for(var i=0; i<searchProviderLen; i++){
					translatedSearchProviderArray[i] = _translateCSSClassName(_selectedSearchProviders[i]);
				}
				return translatedSearchProviderArray;
			},
			
			onSearchProviderSelect: function(selectedMenuItem, event){
				if(selectedMenuItem.get('type') == 'close'){
					dijit.popup.close(selectedMenuItem.getParent());
					return;
				}
				/*String*/
				var itemClass = selectedMenuItem.get('iconClass');
				var untoggledClassName = _getUntoggledClass(itemClass);
				/*Boolean*/
				var wasToggled = _isToggledClass(itemClass);
	            if(wasToggled){
	            	if(_selectedSearchProviders.length > 1){
	            		_removeSelectedSearchProvider(untoggledClassName);
	            	}
	            	else{
	            		return;
	            	}
	            }else{
	            	_addSelectedSearchProvider(untoggledClassName);
	            }
				console.log(itemClass + " is " + (wasToggled == false ? "no longer " : "now ") + " toggled");
	            var newClassName = wasToggled ? untoggledClassName : _getToggledClass(itemClass);
	            console.log("setting new itemClass to "+newClassName);
	            selectedMenuItem.set('iconClass',newClassName);
	            var sp = this.getSearchProviders();
	            console.log(sp);
	            //dojo.stopEvent(event);
	        },
			/**
			 * @return {Handle} dojo handle
			 */
			dojoConnect: function(target /*Object*/, eventName /*String*/, thisObj /*Object*/, handler /*String or Function */){
				return dojo.connect(target, eventName, thisObj ? thisObj : this, handler);
			},
			
			dojoDisconnectByHandle: function (handle /* dojo Handle */){
				dojo.disconnect(handle);
			},
			
			dojoDisconnect: function(/*String*/ handleName){
				if(_handles[handleName]){
					// the 'this' here is not optional
					console.log("disconnecting handle with key "+handleName);
					dojo.disconnect(this.getHandle(handleName));
					return true;
				}
				return false;
			}
		};
		_bindSetter(_onAfterSearchHandler, __API, "onSearchProviderSelect");
		return __API;	
	};
}
