/**
 * 
 * Copyright 2007
 * 
 * Paulius Uza
 * http://www.uza.lt
 * 
 * Dan Florio
 * http://www.polygeek.com
 * 
 * Project website:
 * http://code.google.com/p/custom-context-menu/
 *
 * 
 * SAS Updates: change Right-click to be instance base, short-key support for Shift+F10 & allow constructor to take parameters 
 * --
 * RightClick for Flash Player. 
 * Version 0.6.2
 * 
 */
function RightClick(object,container)  
{
	this.FlashObjectID = object;
	this.FlashContainerID = container;
	this.Cache = this.FlashObjectID;
}
/**
 *  Constructor
 */ 
RightClick.prototype.initialize = function () {
    var self=this;
	if(window.addEventListener){ //firefox
		 window.addEventListener("mousedown", self.onGeckoMouse() , true);
		 window.addEventListener("keydown", function(event) { self.onKeyDown(event); } , true);
	} else { //IE
		document.getElementById(this.FlashContainerID).onmouseup = function() { document.getElementById(self.FlashContainerID).releaseCapture(); }
		document.oncontextmenu = function(obj){ if (!window.event.ctrlKey)  return false; }
		document.getElementById(this.FlashContainerID).onmousedown = function() { if (!window.event.ctrlKey) self.onIEMouse() };
		document.getElementById(this.FlashContainerID).onkeydown = function() { if (!window.event.ctrlKey) self.onKeyDown() } ;
	}
}

RightClick.prototype.onContext = function(obj)
{
	if(window.event.srcElement.id == this.FlashObjectID) { return false; } else { this.Cache = "nan"; }
}
/**
 * GECKO / WEBKIT event overkill
 * @param {Object} eventObject
 */
RightClick.prototype.killEvents = function(eventObject) {
	if(eventObject) {
		if (eventObject.stopPropagation) eventObject.stopPropagation();
		if (eventObject.preventDefault) eventObject.preventDefault();
		if (eventObject.preventCapture) eventObject.preventCapture();
   		if (eventObject.preventBubble) eventObject.preventBubble();
	}
}
/**
 * GECKO / WEBKIT call right click
 * @param {Object} ev
 */
RightClick.prototype.onGeckoMouse = function(ev) {
	var self = this;
  	return function(ev) {
  	if (ev.ctrlKey) return;
    if (ev.button != 0) {
		self.killEvents(ev);
		if(ev.target.id == self.FlashObjectID && self.Cache == self.FlashObjectID) {
		
    		self.call();
		}
		self.Cache = ev.target.id;
	}
  }
}
/**
 * IE call right click
 * @param {Object} ev
 */
RightClick.prototype.onIEMouse = function() {

  	if (event.button > 1) {
  		if(window.event.srcElement.id == this.FlashObjectID && this.Cache == this.FlashObjectID) {
			this.call(); 
		}
		document.getElementById(this.FlashContainerID).setCapture();
		if(window.event.srcElement.id)
		this.Cache = window.event.srcElement.id;
	}
}
/**
 * Main call to Flash External Interface
 */
RightClick.prototype.call = function() {
	document.getElementById(this.FlashObjectID).rightClick();
}

RightClick.prototype.onKeyDown = function(ev) {
	if (!ev)
		ev = window.event;
	if (ev && ev.shiftKey) {
        //if shift+f10, fire rightClick event	
		if (ev.keyCode == 121)
		{
			document.getElementById(this.FlashObjectID).keyboardShortCut();
		}
	}
}
